#---------------------------------------------------------
# This Datapack was made by CommandGeek
# Please do not copy or credit this as your own work!
# Youtube: www.youtube.com/CommandGeek
#---------------------------------------------------------

# Wing
scoreboard players add @e[tag=flying_fish,tag=!wing] FlyingFishWing 1
scoreboard players remove @e[tag=flying_fish,tag=wing] FlyingFishWing 1
tag @e[tag=flying_fish,tag=!wing,scores={FlyingFishWing=15..}] add wing
tag @e[tag=flying_fish,tag=wing,scores={FlyingFishWing=..-15}] remove wing

execute as @e[tag=flying_fish] run scoreboard players operation @s FlyingFishWingW += @s FlyingFishWing 

execute as @e[tag=flying_fish] store result entity @s Pose.RightArm[2] float 0.06 run scoreboard players get @s FlyingFishWingW
execute as @e[tag=flying_fish] store result entity @s Pose.LeftArm[2] float -0.06 run scoreboard players get @s FlyingFishWingW

execute as @e[tag=flying_fish] store result entity @s Pose.RightArm[1] float 0.01 run scoreboard players get @s FlyingFishWingW
execute as @e[tag=flying_fish] store result entity @s Pose.LeftArm[1] float -0.01 run scoreboard players get @s FlyingFishWingW

# Phantom Stuff
execute as @e[tag=flying_fish_ai] run data modify entity @s Fire set value -20s
execute at @e[tag=flying_fish] run particle white_ash ^ ^2 ^1 1 0.2 1 0 5

# Llama stuff
execute as @e[type=llama,tag=flying_fish_ai] if data entity @s DecorItem run data modify entity @s DecorItem set value {}

# Control
execute as @e[type=llama,tag=flying_fish_ai] at @s positioned ~ ~0.8 ~ if entity @a[distance=..0.35,nbt={RootVehicle:{Entity:{Tags:["flying_fish_ai"]}}}] rotated as @p[distance=..0.35,nbt={RootVehicle:{Entity:{Tags:["flying_fish_ai"]}}}] positioned as @s if block ^ ^ ^1.5 #flying_fish:empty run tp @s ^ ^ ^1 facing ^ ^ ^10

# Teleporting
execute as @e[tag=flying_fish] at @e[tag=flying_fish_ai] if score @s FlyingFishID = @e[tag=flying_fish_ai,limit=1,distance=..0.1,sort=nearest] FlyingFishID rotated ~ 0 run tp @s ^ ^-0.2 ^-1.9 facing ^ ^-1 ^1

# Tame / Hostile
execute as @e[type=llama,tag=flying_fish_ai] at @s unless entity @a[distance=..15] run function flying_fish:hostile

execute as @e[type=phantom,tag=flying_fish_ai] at @s if entity @e[type=item,distance=..1.5,nbt={Item:{id:"minecraft:sea_pickle"}}] run function flying_fish:tame

# Launch
execute as @e[tag=flying_fish] unless score @s FlyingFishM matches 1.. at @s if entity @a[distance=..2,nbt={RootVehicle:{Entity:{Tags:["flying_fish_ai"]}}},tag=!scroll,nbt={SelectedItemSlot:0}] run function flying_fish:launch
tag @a[tag=scroll,nbt=!{SelectedItemSlot:0}] remove scroll

# Missile
execute as @e[tag=flying_fish_missile] at @s run tp @s ^ ^ ^1
execute as @e[tag=flying_fish_missile] at @s unless block ~ ~ ~ #flying_fish:empty run function flying_fish:explode
execute as @e[tag=flying_fish_missile] at @s run tp @s ^ ^ ^1
execute as @e[tag=flying_fish_missile] at @s unless block ~ ~ ~ #flying_fish:empty run function flying_fish:explode

execute at @e[tag=flying_fish_missile] run particle minecraft:large_smoke ~ ~1 ~ 0.1 0.1 0.1 0 1
execute at @e[tag=flying_fish_missile] run particle minecraft:flame ~ ~1 ~ 0.1 0.1 0.1 0 1
execute at @e[tag=flying_fish_missile] run playsound minecraft:entity.generic.extinguish_fire master @a ~ ~ ~ 0.1 2

# Reload
scoreboard players remove @e[tag=flying_fish,scores={FlyingFishM=1..}] FlyingFishM 1
execute as @e[tag=flying_fish,scores={FlyingFishM=1}] at @s run function flying_fish:reload

# Natural Spawn
execute as @e[type=salmon] unless predicate flying_fish:natural_spawn run tag @s add flying_fish_tagged
execute as @e[type=salmon,tag=!flying_fish_tagged] at @s run function flying_fish:natural_spawn